#include <iostream.h>
#include <math.h>
#include "pngwriter.h"


void fullfourier(double data[], unsigned long nn, int isign);


int main()
{
   int  xwidth = 512; //Ancho de la imagen
   int  yheight = 512;//altura de la imagen
   int maxcolours = 65535; // Solo queremos dos niveles de color
   int backgroundcolour = 65535; //fondo blanco
   pngwriter myplot(xwidth,yheight,backgroundcolour,"2.png");
   myplot.square(1,1,xwidth,yheight,65535,0,0);
   //Estos son los datos para probar fft
   unsigned long N = 1024;  
   double step = 1/((double) N);
   double * data;
   data = new double[2*N+1];
   
   //double data[2*N+1];
   double arg;
   
   //Lleno el array de datos con una onda sinusoidal SOLO EN LA PARTE REAL DEL ARRAY (ver documentacion)
   //La parte imaginaria es 0 (obvio)
   //Es importante notar que el FFT solo puede mostrar seales de frecuencias menores a la frecuencia de Nyquist,
   //Dada por  fo/2, con fo la freciencia de muestreo.
   //
   // Conclusions: the nyquist frequency appears to be reached when one takes the data as
   // 
   //      arg = (i/N)*M_PI*N
   // 
   // This is equivalent to i*M_PI. This means that, in the whole array of length 1024 real measurements, the sine goes to zero 1024 times.
   // 
   // In other words, the spatial frequency cannot exceed 1/N, where N is the number of spatial points in the interval.
   // At most one cycle-per-pixel.
   
   for(int i = 1; i<N; i++)
     {
        arg = ((double)i/N)*M_PI*0.5;
	data[(2*i-1)] = 10*tan(arg);
	//data[(2*i-1)] = 10*sin(arg) + 9*sin(arg*2) + 8*sin(arg*3) +7*sin(arg*4) + 6*sin(arg*5) + 5*sin(arg*6) + 4*sin(arg*7) + 3*sin(arg*8) + 2*sin(arg*9) + sin(arg*10);
	data[2*i] = 0.0;
     }
   data[2*N] = 0.0;
   
   //fullfourier es el algoritmo de Numerical Recipes, con el nombre cambiado
   
   fullfourier(data, N, 1);
   
   int j,k;
   
   double maxy = 0.0;
   double supermaxy = 0.0;
   cout << "Start" << endl;
   
   //This will output only the positive frequencies.  
   for(j = 1; j<(N/2); j++)
     {  
	//Find maximum to scale image.
	if(sqrt(data[2*j-1]*data[2*j-1] +data[2*j]*data[2*j]) > maxy)
	  {
	     maxy = sqrt(data[2*j-1]*data[2*j-1]+ data[2*j]*data[2*j]);
	     cout << " maxy try " << maxy << endl;                
	  }
     }

   double xplace;
   double ystart;
   double yend;
   
   for(j = 1; j<(N/2); j++)
     {
        xplace = j*(xwidth-1)*2/N;
        ystart = 1;
        yend = yheight*sqrt(data[2*j-1]*data[2*j-1] + data[2*j]*data[2*j])/(maxy*1.1);
	myplot.line(int(xplace),int(ystart),int(xplace), int(yend), 0,30000,30000);
     }

   myplot.close();
   
   return 0;   
}
