#include <iostream.h>
#include <math.h>
#include "pngwriter.h"


void fullfourier(double data[], unsigned long nn, int isign);


int main()
{
    int N = 512; //N complex data points, must be an even number
    double * data;
    data = new double[2*N+1];


    int thecol,therow;
    double abs;
    double outweight = 1000.0;

    ///////////////////////////////////////////////////////////////////////////////pngwriter images section

    int maxcolours = 65535; 
    int backgroundcolour = 0; 
    pngwriter source(N,N,backgroundcolour,"source.png");
    //source.filledsquare(-10+N/2, -10+N/2, 10+N/2, 10+N/2, maxcolours, maxcolours, maxcolours);

    //source.filledcircle(N/2,N/2,20,maxcolours,maxcolours,maxcolours);

    //source.filledsquare(-1+(N/2)+8, 10, 1+(N/2)+8, N-10, maxcolours, maxcolours, maxcolours);
    //source.filledsquare(-1+(N/2)-8, 10, 1+(N/2)-8, N-10, maxcolours, maxcolours, maxcolours);

    for(int xxx = 1; xxx <N+1;xxx = xxx + 30)
      {
        for(int yyy = 1; yyy <N+1;yyy = yyy + 30)
          {
            source.filledsquare(xxx,yyy,xxx+3,yyy+3,maxcolours,maxcolours,maxcolours);
          }
      }


    pngwriter out(N,N,backgroundcolour,"out.png");
    ////////////////////////////////////////////////////////////////////////////////////////////////////
    
    ///////////////////////////////////// tempmatrix memory allocation
    double * * tempmatrix;
    int ii;
    tempmatrix = new double * [2*N+1];
    for( ii = 0; ii<(2*N+1);ii++)
      {
        tempmatrix[ii] = new double[2*N+1];
        if(!tempmatrix[ii])
          {
            cerr << "Error allocating memory for tempmatrix." << endl;
          }
      }
    ////////////////////////////////////////////////////////////////

    for( therow = 1;therow <N+1;therow++) // therow = 1 ... N
     {
       ///////////////////////
       // Read a row from the image and copy the data into data[]
       ///////////////////////
       
       for( thecol = 1; thecol < N+1; thecol++) // thecol = 1 ... N
         {
           data[2*thecol-1] = int(double(source.read(thecol,therow,1))/65535.0); // boxes 1, 3, 5... 2N-1 for real data (0 to 1)
           data[2*thecol] = 0.0; // boxes 2, 4, 6, ... 2N for imaginary data = 0.0
         }
       
       //////////////////////
       //data[] now contains the image row, in a format ready for fft().
       /////////////////////

       fullfourier(data, N, 1);

       //////////////////////
       //data[] now contains the fourier transform of that row. Cant write it back to the image because it needs to be all the data
       // and the image can only contain real data.
       // have to write it to tempmatrix[therow][thecol]
       ///////////////////////

       for( thecol = 1; thecol < N+1; thecol++) // thecol = 1 ... N
         {
           tempmatrix[therow][2*thecol-1] = data[2*thecol-1]; // boxes 1, 3, 5... 2N-1 for real transformed
           tempmatrix[therow][2*thecol] = data[2*thecol]; // boxes 2, 4, 6, ... 2N for imaginary transformed
         }

       //////////////////////
       // This row of tempmatrix[][] now contains the transformed row of the image.
       // it is time to move on to a new row.
       ////////////////////////
     }

    ////////////////////////
    // Now the situation is different.
    // tempmatrix has the top N out of 2N rows filled with meaningful data pairs
    // Now we must iterate over each column, and fill data[] with the complex pairs that
    // are stacked in pairs one on top of the other. These are N pairs in a thick column that is
    // conceptually 2 wide, and when put one on top of the other, single file, and into data will be 2N long.
    ///////////////////////////
    
    for( thecol = 1; thecol < N+1; thecol++) // thecol = 1 ... N
      {

        for( therow = 1;therow <N+1;therow++) // therow = 1 ... N
          {
            data[2*therow-1] = tempmatrix[therow][2*thecol-1];
            data[2*therow] = tempmatrix[therow][2*thecol];
          }

        /////////////////////
        // data[] now has a column of data in it
        /////////////////////
        fullfourier(data, N, 1);

        /////////////////////
        // Now we have to write data[] back to tempmatrix[][].
        // We have already read from the columns 2*thecol -1 and 2*thecol, so
        // we can safely go writing each data[] load into  columns side by side, of index
        // thecol. The resultant tempmatrix[][] will then be N columns wide and 2N columns
        // tall. When we take the power spectrum, this will result in and NxN image.
        /////////////////////

        for( therow = 1;therow <N+1;therow++) // therow = 1 ... N
          {
            tempmatrix[2*therow-1][thecol] = data[2*therow-1];
            tempmatrix[2*therow][thecol] = data[2*therow];   /////??
          }

        ///////////////////////
        // We're done with this column, move on to the next pair of columns
        // to process.
        ///////////////////////

      }

    ////////////////////////////
    // As said before, tempmatrix[][] now contains the transformed image, though not in the traditional
    // "zero freq at center" style.
    ////////////////////////////

    ///////////////////////////
    // Now we can finally take a look, and we write the power spectrum to the image.
    /////////////////////////////


    ////////////////////////////
    // First, however, we must normalize the data, by finding the largest pixel
    ////////////////////////////

    
    outweight = 0.0;

    for( therow = 1;therow <N+1;therow++) // therow = 1 ... N
      {
        for( thecol = 1;thecol <N+1;thecol++) // therow = 1 ... N
          {
            abs = sqrt( tempmatrix[2*therow-1][thecol]*tempmatrix[2*therow-1][thecol]  + tempmatrix[2*therow][thecol]*tempmatrix[2*therow][thecol]);
            if( abs>outweight)
              {
                outweight = abs;
              }
          }
      }
    

    
    for( therow = 1;therow <N+1;therow++) // therow = 1 ... N
      {
        for( thecol = 1;thecol <N+1;thecol++) // therow = 1 ... N
          {
            abs = sqrt( tempmatrix[2*therow-1][thecol]*tempmatrix[2*therow-1][thecol]  + tempmatrix[2*therow][thecol]*tempmatrix[2*therow][thecol]);
            abs = maxcolours*(abs/outweight);
            out.plot(thecol,therow,int(abs),int(abs),int(abs));
            //cout << abs << "\t";
          }
      }

    /////////////////////////
    // Lastly, we must rearrange the image quadrants to follow the convention of f=0 at the center
    // To save memory, we can use data[] even though it is 2N and we need N long
    //////////////////////

    int value;
    /// Top right goes to bottom left
    for( therow = 1;therow <(N/2)+1;therow++) // therow = 1 ... N
      {
        // Read row from bottom left into data[]
        for( thecol = 1;thecol <(N/2)+1;thecol++) // therow = 1 ... N
          {
            data[thecol] = out.read(thecol, therow, 1);
          }

        // copy row from top right to vacated bottom left row
        for( thecol = 1;thecol <(N/2)+1;thecol++) // therow = 1 ... N
          {
            value = out.read(thecol+(N/2), therow+(N/2), 1);
            out.plot(thecol, therow, value, value, value);
          }

        // read from from data into vacated top right row
        for( thecol = 1;thecol <(N/2)+1;thecol++) // therow = 1 ... N
          {
            value = data[thecol];
            out.plot(thecol + (N/2), therow+(N/2), value, value, value);
          }
      }

    /// Top left goes to bottom right
    for( therow = 1;therow <(N/2)+1;therow++) // therow = 1 ... N
      {
        // Read row from top left into data[]
        for( thecol = 1;thecol <(N/2)+1;thecol++) // therow = 1 ... N
          {
            data[thecol] = out.read(thecol, therow + N/2, 1);
          }

        // copy row from bottom right to vacated top left row
        for( thecol = 1;thecol <(N/2)+1;thecol++) // therow = 1 ... N
          {
            value = out.read(thecol+N/2, therow, 1);
            out.plot(thecol, therow+N/2, value, value, value);
          }

        // read from from data into vacated bottom right row
        for( thecol = 1;thecol <(N/2)+1;thecol++) // therow = 1 ... N
          {
            value = data[thecol];
            out.plot(thecol + (N/2), therow, value, value, value);
          }
      }

            
   source.close();
   out.close();
   for( ii = 0; ii<(2*N+1);ii++)
     {
       delete [] tempmatrix[ii];

     }
   delete [] tempmatrix;
   delete [] data;
   
   return 0;   
}
